#! /bin/sh
set -e

amd64="kapok"
i386="cardamom"
powerpc="royal"
arm="kishi00"
arm64="magic"
ppc64el="fisher01"

mkdir -p /home/ubuntu-archive/public_html/livefs-build-logs
cd /home/ubuntu-archive/public_html/livefs-build-logs
find . -type d -name latest -print0 | xargs -r -0 rm -rf
find . -type d -name current -print0 | xargs -r -0 rm -rf

if [ -t 1 ]; then
    VERBOSE=:
else
    VERBOSE=false
fi

mirror () {
    local machine ret
    machine="$1"
    ret=:
    if $VERBOSE; then
        echo "$(date): starting mirror for $machine"
    fi
    wget -q --mirror -np -nH --cut-dirs=2 -A out http://$machine.buildd/~buildd/LiveCD/ \
    || ret=false
    if $VERBOSE; then
        echo -n "$(date): finished mirror for $machine "
        if $ret; then
            echo "(success)"
        else
            echo "(failed)"
        fi
    fi
    $ret
}

for machine in $amd64 $i386 $powerpc $arm $arm64 $ppc64el; do
    mirror "$machine" &
    RES="$RES $!"
done

for proc in $RES; do
    wait $proc && retval=0
done

if [ "$retval" != 0 ]; then
    echo "LiveFS log mirroring had a sad"
fi
